package com.maroontress.madangler.client;

import com.google.gwt.http.client.Request;
import com.google.gwt.http.client.Response;
import com.google.gwt.user.client.ui.Button;
import com.google.gwt.user.client.ui.ClickListener;
import com.google.gwt.user.client.ui.TextArea;
import com.google.gwt.user.client.ui.VerticalPanel;
import com.google.gwt.user.client.ui.Widget;
import com.maroontress.madangler.client.request.Parameters;
import com.maroontress.madangler.client.request.RequestKit;
import com.maroontress.madangler.client.request.RequestListener;

/**
   ɽǤ
*/
public class PublicKeyDialog extends Dialog {

    /** ɽƥȥꥢ */
    private TextArea key;

    /** Ĥܥ */
    private Button okButton;

    /** ꥯȥå */
    private RequestKit kit;

    /** ꥯȥꥹ */
    private RequestListener loadedListener;

    /**
       ɽޤ
    */
    public PublicKeyDialog() {
	setText("Public Key");

	key = new TextArea();
	key.setReadOnly(true);
	key.setCharacterWidth(80);
	key.setVisibleLines(4);

	okButton = new Button("Ok");
	okButton.addClickListener(new ClickListener() {
	    public void onClick(final Widget sender) {
		hide();
	    }
	});

	VerticalPanel vp = new VerticalPanel();
	vp.add(key);
	vp.add(okButton);
	vp.setCellHorizontalAlignment(okButton, VerticalPanel.ALIGN_CENTER);
	setWidget(vp);

	kit = new RequestKit();
        loadedListener = new RequestListener() {
	    public void startRequest() {
		setLoading(true);
	    }
	    public void stopRequest() {
		setLoading(false);
	    }
	    public void responseReceived(final Request req,
					 final Response res) {
		key.setText(res.getText());
	    }
	    public void errorThrown(final Request req,
				    final Throwable e) {
		MadAngler.alert(e.getMessage());
	    }
	};
    }

    /**
       ֤̿ꤷޤ

       @param b trueξ̿桢false̿
    */
    private void setLoading(final boolean b) {
        MadAngler.setLoading(b);
	key.setEnabled(!b);
        okButton.setEnabled(!b);
    }

    /**
       濴ɽޤ
    */
    public void center() {
	super.center();
	kit.cancel();
	key.setText("");

	Parameters params = new Parameters();
	params.add("method", "getPublicKey");
	kit.sendRequest(params.toString(), loadedListener);
    }
}
